using Microsoft.VisualStudio.TestTools.UnitTesting;
using TestSessionLib;

namespace TestProject
{
    /*,   5   5  */

    [TestClass]
    public class UnitTest
    {
/*  */

        /// <summary>
        /// ,   CheckMark  true   
        /// </summary>
        [TestMethod]
        public void CheckMark_IsTrue()
        {
            Assert.IsTrue(REG_MARK_LIB.CheckMark("a999aa052"));
        }

        /// <summary>
        /// ,   CheckMark    boolean.
        /// </summary>
        [TestMethod]
        public void CheckMark_IsBoolean()
        {
            Assert.IsInstanceOfType(REG_MARK_LIB.CheckMark("a999aa052"), typeof(Boolean));
        }

        /// <summary>
        /// ,      GetNextMarkAfter  
        ///   .
        /// </summary>
        [TestMethod]
        public void NextMarkAfter_AreEqual()
        {
            Assert.AreEqual(REG_MARK_LIB.GetNextMarkAfter("a125aa052"), "a126aa052");
        }

        /// <summary>
        /// ,      GetNextMarkAfterInRange  
        ///   .
        /// </summary>
        [TestMethod]
        public void NextMarkAfterInRange_AreEqual()
        {
            Assert.AreEqual(REG_MARK_LIB.GetNextMarkAfterInRange("a125aa052", "a000aa052", "a999aa052"), "a126aa052");
        }

        /// <summary>
        /// ,      GetCombinationsCountInRange  
        ///   .
        /// </summary>
        [TestMethod]
        public void CombinationsCountInRange_AreEqual()
        {
            Assert.AreEqual(REG_MARK_LIB.GetCombinationsCountInRange("a000aa053", "a003aa053"), 4);
        }

        /*  */

        /// <summary>
        /// ,     GetNextMarkAfterInRange  
        ///     ,  .
        /// </summary>
        [TestMethod]
        public void GetNextMarkAfterInRange_RangeNotOrder()
        {
            Assert.ThrowsException<System.ArgumentException>(() => REG_MARK_LIB.GetNextMarkAfterInRange("123052", "a999aa052", "a000aa052"));
        }

        /// <summary>
        /// ,     GetCombinationsCountInRange  
        ///     ,  .
        /// </summary>
        [TestMethod]
        public void CombinationsCountInRange_RangeNotBy()
        {
            Assert.ThrowsException<System.ArgumentOutOfRangeException>(() => REG_MARK_LIB.GetCombinationsCountInRange("a010aa799", "a003aa799"));
        }

        /// <summary>
        /// ,   GetNextMarkAfter    .
        /// </summary>
        [TestMethod]
        public void GetNextMarkAfter_InvalidParametr()
        {
            Assert.ThrowsException<System.ArgumentException>(() => REG_MARK_LIB.GetNextMarkAfter("a999aa999"));
        }

        /// <summary>
        /// ,   GetNextMarkAfter    .
        /// </summary>
        [TestMethod]
        public void GetNextMarkAfterInRange_InvalidParametr()
        {
            Assert.ThrowsException<System.ArgumentException>(() => REG_MARK_LIB.GetNextMarkAfterInRange("123052", "a000aa052", "a999aa052"));
        }

        /// <summary>
        /// ,   GetNextMarkAfter    .
        /// </summary>
        [TestMethod]
        public void GetCombinationsCountInRange_InvalidParametr()
        {
            Assert.ThrowsException<System.ArgumentException>(() => REG_MARK_LIB.GetCombinationsCountInRange("12345678", "a003aa053"));
        }
    }
}